// PROCE55 _function_defs.js
//
// PROCE55 system functions:
var PROCE55 = require('./PROCE55_functions.js');

// =========================================================
// Exported functions (accessible outside _function_defs.js)
// message = Object type: PROCE55.P55Message)

module.exports = {

  P55_UPCGetProduct: function (message) {
    console.log("Executed function: " + message.FunctionName);
    // function logic
    var resp = P55_UPCGetProduct_getResponse(message);
    return resp;
  },
  
};
// =========================================================


// internal functions (not accessible outside _function_defs.js)
//

var P55_UPCGetProduct_getResponse = function (message) {
  var CODE = PROCE55.GetParamValue( message, "CODE" );
  console.log("CODE:"+CODE);

  // Create response message object
  var resp = new PROCE55.P55Message();  

  // process SOAP call
  var ret = UPCGetProduct(CODE);

  // process CSV response
  var array = CSVToArray(ret);
  var line = array[1];

  console.log("DESCR:"+line[0]);
  console.log("PICTURE:"+line[1]);


  var descr = new PROCE55.P55Param("DESCR",line[0]);
  var picture = new PROCE55.P55Param("PICTURE",line[1]);
  
  resp.Parameters.push(descr);
  resp.Parameters.push(picture);
    
  return resp;
}

var UPCGetProduct = function (upc) {

  var res;
  var responseAsCsv;

  var maxcnt = 50;
  var waitms = 200;
  var timeout = maxcnt * waitms;
  var cnt;
  var sleep = require('system-sleep');

  var soap = require('soap');
  var url = 'http://www.searchupc.com/service/UPCSearch.asmx?wsdl';
//<wsdl:types>
//<s:schema targetNamespace="http://searchupc.com/" elementFormDefault="qualified">
//<s:element name="GetProduct">
//<s:complexType>
//<s:sequence>
//<s:element name="upc" type="s:string" maxOccurs="1" minOccurs="0"/>
//<s:element name="accesstoken" type="s:string" maxOccurs="1" minOccurs="0"/>
//</s:sequence>
//</s:complexType>
//</s:element>
//<s:element name="GetProductResponse">
//<s:complexType>
//<s:sequence>
//<s:element name="GetProductResult" type="s:string" maxOccurs="1" minOccurs="0"/>
//</s:sequence>
//</s:complexType>
//</s:element>

  var args = {
         upc : upc, //'608939448896',  
         accesstoken : '--- insert your access token here ---',   
  };

  soap.createClient(url, function(err, client) {
      client.GetProduct(args, function(err, result) {
        if (err){
          return 'Error';
        }
        //console.log(result);
        responseAsCsv = result.GetProductResult;        
        res = result;
        cnt = maxcnt;
        }, {timeout: timeout});
      });

  for (cnt = 1; cnt <= maxcnt; cnt++) {
    console.log('... waiting for async response for ' + cnt*waitms + ' ms');
    sleep(waitms);
  }

  console.log(res);
  return responseAsCsv;
}

// http://stackoverflow.com/questions/1293147/javascript-code-to-parse-csv-data
var CSVToArray = function( strData, strDelimiter ){
        // Check to see if the delimiter is defined. If not then default to comma.
        strDelimiter = (strDelimiter || ",");

        // Create a regular expression to parse the CSV values
        var objPattern = new RegExp(
            (
                // Delimiters.
                "(\\" + strDelimiter + "|\\r?\\n|\\r|^)" +
                // Quoted fields.
                "(?:\"([^\"]*(?:\"\"[^\"]*)*)\"|" +
                // Standard fields.
                "([^\"\\" + strDelimiter + "\\r\\n]*))"
            ),
            "gi"
            );

        // Create an array to hold our data. Give the array a default empty first row.
        var arrData = [[]];

        // Create an array to hold our individual pattern matching groups.
        var arrMatches = null;

        // Keep looping over the regular expression matches until we can no longer find a match.
        while (arrMatches = objPattern.exec( strData )){

            // Get the delimiter that was found.
            var strMatchedDelimiter = arrMatches[ 1 ];

            // Check to see if the given delimiter has a length
            // (is not the start of string) and if it matches
            // field delimiter. If id does not, then we know
            // that this delimiter is a row delimiter.
            if (
                strMatchedDelimiter.length &&
                strMatchedDelimiter !== strDelimiter
                ){

                // Since we have reached a new row of data,
                // add an empty row to our data array.
                arrData.push( [] );
            }

            var strMatchedValue;

            // Now that we have our delimiter out of the way,
            // let's check to see which kind of value we
            // captured (quoted or unquoted).
            if (arrMatches[ 2 ]){
                // We found a quoted value. When we capture
                // this value, unescape any double quotes.
                strMatchedValue = arrMatches[ 2 ].replace(
                    new RegExp( "\"\"", "g" ),
                    "\""
                    );
            } else {
                // We found a non-quoted value.
                strMatchedValue = arrMatches[ 3 ];
            }

            // Now that we have our value string, let's add
            // it to the data array.
            arrData[ arrData.length - 1 ].push( strMatchedValue );
        }

        // Return the parsed data.
        return( arrData );
    }


